#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "parse.y"
#include <stdio.h> 
#include <grp.h>
#include "idled.h"
#include <pwd.h>

#ifndef DEBUG
#define DEBUG 0
#endif

#define debug if (DEBUG > 0) logfile

int		num;
char		*name;
struct	group	*grp;

extern	char	*yytext;

extern	char	*config_file;	/* The name of the config file, from idled.c */
extern  char    *strchr();
extern	void	addlist();

  /************************************************************************
   *  The order of the tokens in the *first line* is significant.         *
   *                                                                      *
   *  They dictate which rules and exemptions have precedence.            *
   *  Hence, TTY has precedence over HOST has precedence over LOGIN, etc. *
   *                                                                      *
   *  The second two %token lines may be ordered anyway.                  *
   *  DEFAULT is the least specific, but will always match.               *
   *  It must always remain in the last position.                         *
   ************************************************************************/
#line 43 "parse.y"
typedef union {
	char *sb; 
	int nb;
       } YYSTYPE;
#line 43 "y.tab.c"
#define TTY 257
#define HOST 258
#define LOGIN 259
#define GROUP 260
#define FILECOM 261
#define DEFAULT 262
#define EXEMPT 263
#define TIMEOUT 264
#define SLEEP 265
#define WARN 266
#define IDLEMETHOD 267
#define CONSWINS 268
#define SESSION 269
#define REFUSE 270
#define MULTIPLES 271
#define NUM 272
#define IDLE 273
#define MULTIPLE 274
#define NAME 275
#define ALL 276
#define THRESHOLD 277
#define NL 278
#define USERINPUT 279
#define INPUTOUTPUT 280
#define NORMAL 281
#define OFF 282
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   12,   12,   12,    4,    4,    4,    6,
    6,    6,   11,   11,   11,   11,   11,    5,    5,    5,
    5,    7,    7,    8,    8,    9,    9,    9,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   13,   13,
    1,    3,    3,    3,    3,    2,    2,    2,    2,    2,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    3,    2,    4,    4,    3,    4,    5,    3,    3,
    4,    3,    4,    5,    4,    4,    3,    4,    5,    4,
    3,    3,    3,    3,    3,    3,    3,    3,    4,    4,
    4,    4,    4,    4,    4,    4,    4,    3,    3,    3,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
};
short yydefred[] = {                                      1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   13,    2,    3,    4,    5,    6,    7,    8,
    9,   10,   11,   12,    0,   55,   53,   52,   54,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   19,    0,   60,   59,   57,   58,   56,    0,   51,   31,
    0,    0,    0,   33,   32,   35,   34,   38,   36,   37,
   48,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   27,    0,    0,    0,    0,   22,    0,   20,   50,   49,
   16,    0,    0,    0,   17,    0,   30,   28,   42,   43,
   44,   39,   40,   41,   45,   46,   47,    0,   25,   26,
   23,   21,   15,   14,   18,   29,   24,
};
short yydgoto[] = {                                       1,
   31,   68,   32,   14,   15,   16,   17,   18,   19,   20,
   21,   22,   23,
};
short yysindex[] = {                                      0,
 -252, -276, -185, -192, -251, -228, -256, -236, -210, -179,
 -227, -247,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -275,    0,    0,    0,    0, -267,
 -215, -265, -244, -239, -241, -237, -235, -222, -221, -195,
 -194, -193, -191, -190, -242, -240, -219, -189, -184, -186,
 -182, -180, -183, -181, -178, -177, -176, -175, -174, -173,
    0, -215,    0,    0,    0,    0,    0, -172,    0,    0,
 -168, -171, -170,    0,    0,    0,    0,    0,    0,    0,
    0, -169, -167, -166, -165, -164, -163, -162, -161, -160,
    0, -153, -158, -157, -156,    0, -155,    0,    0,    0,
    0, -154, -152, -151,    0, -150,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, -149,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
short yyrindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,
};
short yygindex[] = {                                      0,
   -3,   31,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,
};
#define YYTABLESIZE 129
short yytable[] = {                                      41,
   36,   24,   61,    2,   37,   52,   55,   62,   58,   69,
    3,    4,    5,    6,    7,    8,    9,   10,   11,   44,
   38,   59,   42,   43,   12,   13,   60,   39,   56,   82,
   72,   85,   45,   70,   73,   71,   46,   47,   83,   84,
   86,   87,   74,   40,   57,   48,   26,   27,   28,   29,
   49,   50,   88,   63,   64,   75,   76,   65,   66,   51,
   67,   89,   90,   33,   26,   27,   28,   29,   34,   35,
   25,   26,   27,   28,   29,   30,   53,   26,   27,   28,
   29,   54,   77,   78,   79,   93,   80,   81,   91,   94,
   92,   95,  104,   97,   96,    0,    0,  102,  103,   98,
   99,  100,  101,  106,    0,  105,  107,  108,  109,    0,
  110,  111,  112,  113,  114,  115,  116,  117,  118,  119,
  120,  121,  122,  123,    0,  124,  125,  126,  127,
};
short yycheck[] = {                                     256,
    4,  278,  278,  256,  256,    9,   10,  275,  256,  275,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  256,
  272,  269,  279,  280,  277,  278,  274,  256,  256,  272,
  272,  272,  269,  278,  272,  275,  273,  274,  281,  282,
  281,  282,  278,  272,  272,  256,  257,  258,  259,  260,
  261,  262,  272,  269,  270,  278,  278,  273,  274,  270,
  276,  281,  282,  256,  257,  258,  259,  260,  261,  262,
  256,  257,  258,  259,  260,  261,  256,  257,  258,  259,
  260,  261,  278,  278,  278,  272,  278,  278,  278,  272,
  275,  272,   62,  275,  278,   -1,   -1,  272,  272,  278,
  278,  278,  278,  272,   -1,  278,  278,  278,  278,   -1,
  278,  278,  278,  278,  278,  278,  278,  278,  272,  278,
  278,  278,  278,  278,   -1,  278,  278,  278,  278,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 282
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TTY","HOST","LOGIN","GROUP",
"FILECOM","DEFAULT","EXEMPT","TIMEOUT","SLEEP","WARN","IDLEMETHOD","CONSWINS",
"SESSION","REFUSE","MULTIPLES","NUM","IDLE","MULTIPLE","NAME","ALL","THRESHOLD",
"NL","USERINPUT","INPUTOUTPUT","NORMAL","OFF",
};
char *yyrule[] = {
"$accept : cmd_cmd",
"cmd_cmd :",
"cmd_cmd : cmd_cmd exempt_cmd",
"cmd_cmd : cmd_cmd idle_cmd",
"cmd_cmd : cmd_cmd refuse_cmd",
"cmd_cmd : cmd_cmd sleep_cmd",
"cmd_cmd : cmd_cmd warn_cmd",
"cmd_cmd : cmd_cmd idlemethod_cmd",
"cmd_cmd : cmd_cmd conswins_cmd",
"cmd_cmd : cmd_cmd session_cmd",
"cmd_cmd : cmd_cmd thresh_cmd",
"cmd_cmd : cmd_cmd mult_cmd",
"cmd_cmd : cmd_cmd error NL",
"cmd_cmd : cmd_cmd NL",
"thresh_cmd : THRESHOLD MULTIPLE NUM NL",
"thresh_cmd : THRESHOLD SESSION NUM NL",
"thresh_cmd : THRESHOLD error NL",
"exempt_cmd : EXEMPT who exempt_type NL",
"exempt_cmd : EXEMPT FILECOM NAME exempt_type NL",
"exempt_cmd : EXEMPT error NL",
"refuse_cmd : REFUSE who NL",
"refuse_cmd : REFUSE FILECOM NAME NL",
"refuse_cmd : REFUSE error NL",
"session_cmd : SESSION who NUM NL",
"session_cmd : SESSION FILECOM NAME NUM NL",
"session_cmd : SESSION DEFAULT NUM NL",
"session_cmd : SESSION REFUSE NUM NL",
"session_cmd : SESSION error NL",
"idle_cmd : TIMEOUT who NUM NL",
"idle_cmd : TIMEOUT FILECOM NAME NUM NL",
"idle_cmd : TIMEOUT DEFAULT NUM NL",
"idle_cmd : TIMEOUT error NL",
"sleep_cmd : SLEEP NUM NL",
"sleep_cmd : SLEEP error NL",
"warn_cmd : WARN NUM NL",
"warn_cmd : WARN error NL",
"idlemethod_cmd : IDLEMETHOD USERINPUT NL",
"idlemethod_cmd : IDLEMETHOD INPUTOUTPUT NL",
"idlemethod_cmd : IDLEMETHOD error NL",
"conswins_cmd : CONSWINS IDLE NUM NL",
"conswins_cmd : CONSWINS IDLE NORMAL NL",
"conswins_cmd : CONSWINS IDLE OFF NL",
"conswins_cmd : CONSWINS SESSION NUM NL",
"conswins_cmd : CONSWINS SESSION NORMAL NL",
"conswins_cmd : CONSWINS SESSION OFF NL",
"conswins_cmd : CONSWINS MULTIPLE NUM NL",
"conswins_cmd : CONSWINS MULTIPLE NORMAL NL",
"conswins_cmd : CONSWINS MULTIPLE OFF NL",
"conswins_cmd : CONSWINS error NL",
"mult_cmd : MULTIPLES NUM NL",
"mult_cmd : MULTIPLES error NL",
"who : name_type NAME",
"name_type : LOGIN",
"name_type : HOST",
"name_type : GROUP",
"name_type : TTY",
"exempt_type : ALL",
"exempt_type : IDLE",
"exempt_type : MULTIPLE",
"exempt_type : REFUSE",
"exempt_type : SESSION",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 275 "parse.y"

static	int	errorcnt = 0;



int
yyerror(sb)
   char *sb;
{
	extern	int	linenum;

	logfile("%s: line %d: %s", config_file, linenum, sb);
	errorcnt++;
	return 0;
}



int
yywrap()
{
	extern	int	linenum;
        extern  time_t  conf_oldstamp;

	if ( errorcnt > 0 && conf_oldstamp <= 1 )
	{
	    logfile("Aborting due to conf file syntax errors.");
	    exit(1);
	}

	linenum = 1;
	return 1;
}

#ifndef HAVE_YYRESTART
void yyrestart(handle)
   FILE *handle;
{
        extern  int     linenum;

        linenum = 1;
}
#endif

/**************************************************************************
 * Reads in more rules from a separate file, which contains the           *
 * login names of the users for that type, one per line.                  *
 **************************************************************************/
void filecom_parse(type,filename,param)
   int type;               /* REFUSE, SESSION, TIMEOUT, or EXEMPT */
   char *filename;
   int param;              /* idle/session time or exempt type */
{
   FILE *handle;
   handle = fopen(filename,"r");
   if (handle == NULL)
   {
      char *buffer;
      buffer = (char *) malloc(20+sizeof(filename));
      sprintf(buffer,"Could not open file '%s'",filename);
      yyerror(buffer);
      free(buffer);
   }
   else
   {
      char lname[NAMELEN+1], trash[100], *c;
      while (!feof(handle) && (fgets(lname,NAMELEN+1,handle) != NULL))
      {
         /* If we didn't read in the newline, do so now */
         if (strchr(lname,'\n') == NULL)
            fscanf(handle,"%[^\n]\n",trash);

         /* First, strip away beyond the first space or newline */
         c = strchr(lname,' ');  if (c != NULL) *c = '\0';
         c = strchr(lname,'\n'); if (c != NULL) *c = '\0';

         if ((int)strlen(lname) > 0)
         {
            char *username;
            username = (char *) malloc (strlen(lname)+1);
            strcpy(username,lname);
            switch(type)
            {
               case REFUSE:
                  debug("Refusing user %s.",username);
                  addlist(refuse, LOGIN, username, 0, 0);
                  break;
               case SESSION:
                  debug("Session Limiting user %s to %d minutes.",username,param);
                  addlist(session, LOGIN, username, 0, param);
                  break;
               case TIMEOUT:
                  debug("Setting Idle timeout for user %s to %d minutes.",username,param);
                  addlist(rules, LOGIN, username, 0, param);
                  break;
               case EXEMPT:
                  debug("Exempting user %s from type %d.",username,param);
                  addlist(exmpt, LOGIN, username, 0, param);
                  break;
            }
         }
      }
   }
}

#line 384 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 14:
#line 72 "parse.y"
{
			m_threshold = yyvsp[-1].nb; 
		}
break;
case 15:
#line 76 "parse.y"
{
			s_threshold = yyvsp[-1].nb; 
		}
break;
case 16:
#line 80 "parse.y"
{
			yyerror("Malformed threshold command.");
		}
break;
case 17:
#line 87 "parse.y"
{
			addlist(exmpt, yyvsp[-2].nb, name, num, yyvsp[-1].nb);
		}
break;
case 18:
#line 91 "parse.y"
{
                        filecom_parse(EXEMPT,yyvsp[-2].sb,yyvsp[-1].nb);
		}
break;
case 19:
#line 95 "parse.y"
{
			yyerror("Malformed exempt command.");
		}
break;
case 20:
#line 101 "parse.y"
{
			addlist(refuse, yyvsp[-1].nb, name, num, 0);
		}
break;
case 21:
#line 105 "parse.y"
{
                        filecom_parse(REFUSE,yyvsp[-1].sb,/* time or thing if any */0);
                }
break;
case 22:
#line 109 "parse.y"
{
			yyerror("Malformed refuse command.");
		}
break;
case 23:
#line 115 "parse.y"
{
			addlist(session, yyvsp[-2].nb, name, num, yyvsp[-1].nb);
		}
break;
case 24:
#line 119 "parse.y"
{
                        filecom_parse(SESSION,yyvsp[-2].sb,yyvsp[-1].nb);
		}
break;
case 25:
#line 123 "parse.y"
{
			session_default = yyvsp[-1].nb;
		}
break;
case 26:
#line 127 "parse.y"
{
			sess_refuse_len = yyvsp[-1].nb * 60;
		}
break;
case 27:
#line 131 "parse.y"
{
			yyerror("Malformed session command.");
		}
break;
case 28:
#line 137 "parse.y"
{
			addlist(rules, yyvsp[-2].nb, name, num, yyvsp[-1].nb);
		}
break;
case 29:
#line 141 "parse.y"
{
                        filecom_parse(TIMEOUT,yyvsp[-2].sb,yyvsp[-1].nb);
		}
break;
case 30:
#line 145 "parse.y"
{
			addlist(rules, DEFAULT, NULL, 0, yyvsp[-1].nb);
		}
break;
case 31:
#line 149 "parse.y"
{
			yyerror("Malformed timeout command.");
		}
break;
case 32:
#line 155 "parse.y"
{
			sleeptime = yyvsp[-1].nb;
		}
break;
case 33:
#line 159 "parse.y"
{
			yyerror("Malformed sleep command.");
		}
break;
case 34:
#line 165 "parse.y"
{
			warntime = yyvsp[-1].nb;
		}
break;
case 35:
#line 169 "parse.y"
{
			yyerror("Malformed warn command.");
		}
break;
case 36:
#line 175 "parse.y"
{
			ioidle = FALSE;
		}
break;
case 37:
#line 179 "parse.y"
{
			ioidle = TRUE;
                }
break;
case 38:
#line 183 "parse.y"
{
			yyerror("Malformed idlemethod command.");
		}
break;
case 39:
#line 189 "parse.y"
{
			conswins_idle = yyvsp[-1].nb * 60;
		}
break;
case 40:
#line 193 "parse.y"
{
                        conswins_idle = -2;
                }
break;
case 41:
#line 197 "parse.y"
{
                        conswins_idle = -1;
                }
break;
case 42:
#line 201 "parse.y"
{
			conswins_sess = yyvsp[-1].nb * 60;
		}
break;
case 43:
#line 205 "parse.y"
{
                        conswins_sess = -2;
                }
break;
case 44:
#line 209 "parse.y"
{
                        conswins_sess = -1;
                }
break;
case 45:
#line 213 "parse.y"
{
			conswins_mult = yyvsp[-1].nb;
		}
break;
case 46:
#line 217 "parse.y"
{
                        conswins_mult = -2;
                }
break;
case 47:
#line 221 "parse.y"
{
                        conswins_mult = -1;
                }
break;
case 48:
#line 225 "parse.y"
{
			yyerror("Malformed cons(ole) win(dow)s command.");
		}
break;
case 49:
#line 231 "parse.y"
{
			mult_per_user = yyvsp[-1].nb;
		}
break;
case 50:
#line 235 "parse.y"
{
			yyerror("Malformed multiples command.");
		}
break;
case 51:
#line 241 "parse.y"
{ 
			yyval.nb = yyvsp[-1].nb;
			name = yyvsp[0].sb;

			if (yyvsp[-1].nb == GROUP)
			{
				grp = getgrnam(name);
				if (grp != NULL)
                                	num = grp->gr_gid;
				else
					logfile("Error parsing conf file:  unknown group name '%s'.",name);
			}
			if (yyvsp[-1].nb == LOGIN)
			{
				if (getpwnam(name) == NULL)
					logfile("Warning parsing conf file:  unknown login name '%s'.",name);
			}
		}
break;
case 52:
#line 261 "parse.y"
{ yyval.nb = LOGIN;   }
break;
case 53:
#line 262 "parse.y"
{ yyval.nb = HOST;    }
break;
case 54:
#line 263 "parse.y"
{ yyval.nb = GROUP;   }
break;
case 55:
#line 264 "parse.y"
{ yyval.nb = TTY;     }
break;
case 56:
#line 267 "parse.y"
{ yyval.nb = ALL; 	 }
break;
case 57:
#line 268 "parse.y"
{ yyval.nb = IDLE; 	 }
break;
case 58:
#line 269 "parse.y"
{ yyval.nb = MULTIPLE; }
break;
case 59:
#line 270 "parse.y"
{ yyval.nb = REFUSE;	 }
break;
case 60:
#line 271 "parse.y"
{ yyval.nb = SESSION;  }
break;
#line 803 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
